
#include "stdio.h"
#include "c6x.h"

#define EVTFLAG0           (*(volatile unsigned int*)0x01800000)
#define EVTSET0            (*(volatile unsigned int*)0x01800020)
#define EVTCLR0            (*(volatile unsigned int*)0x01800040)
#define EVTCLR1            (*(volatile unsigned int*)0x01800044)
#define EVTCLR2            (*(volatile unsigned int*)0x01800048)
#define EVTCLR3            (*(volatile unsigned int*)0x0180004c)
#define INTMUX3            (*(volatile unsigned int*)0x0180010c)
#define INTMUX2            (*(volatile unsigned int*)0x01800108)

extern far void vectors();

unsigned int NMI_counter = 0;

interrupt  void c_NMI(void)
{
//	printf("/n NMI interrupt entered!\n");
	NMI_counter++;
}


void InitDspIntc()
{
	unsigned int temp;
	printf("Configure DSP interrupt controller!\n");

	EVTCLR0 = 0xFFFFFFFF; //Clear ALL interrupt status
	EVTCLR1 = 0xFFFFFFFF;
	EVTCLR2 = 0xFFFFFFFF; 
	EVTCLR3 = 0xFFFFFFFF;
	 
//	INTMUX3 = (INTMUX3&0xffff0000)|0x4100;//Map #65 event to DSP interrupt #13
    INTMUX2 = (INTMUX2 & 0xff00ffff)|0x00080000;  //Map EDMA0_CC0(8) to DSP interrupt #10
//    INTMUX2 = (INTMUX2&0x00ffffff)|0x57000000;  //Map McBSP RX(87) to DSP interrupt #11
//    INTMUX3 = (INTMUX3&0xffffff00)|0x00000058;  //Map McBSP TX(88) to DSP interrupt #12

    /* Set interrupt vector address */
	temp = ISTP;
	temp &= 0x03ff; // aligne to 1Kbyte
	temp |= (unsigned int)vectors;
	ISTP = temp; 

	ICR=0xfff0;//Clear status in IFR, bit 0~3 is reserved.
	
//	IER=0x00001802;//Enable Int 11,12 and NMIE to enable globle interrupts
	IER=0x00000402;//Enable Int 10 and NMIE to enable globle interrupts	
		
	CSR |= 1;  //Enable GIE.
}

